%-------------------------------------------------------------------------%
%                                                                         %
% Amplitude-Signal Spectral Density for Dual PD Amp -- measures           %
%   the noise output from the board                                       %
% Data from SR785                                                         %
%                                                                         %
%-------------------------------------------------------------------------%

%% Board Side B:

%D0 = Off, D1 = Off, Span 12.8KHz
%data15 = importdata('SRS015.mat');
data48 = importdata('SRS048.mat');
%D0 = Off, D1 = Off, Span 102.4KHz
%data16 = importdata('SRS016.mat');
data47 = importdata('SRS047.mat');
%D0 = Off, D1 = Off, Span 1.6KHz
%data17 = importdata('SRS017.mat');
data49 = importdata('SRS049.mat');
%D0 = Off, D1 = Off, Span 200Hz
%data18 = importdata('SRS018.mat');
%data19 = importdata('SRS019.mat');
data50 = importdata('SRS050.mat');

%D0 = On, D1 = Off, Span 102.4KHz
%data20 = importdata('SRS020.mat');
%data33 = importdata('SRS033.mat');
data51 = importdata('SRS051.mat');
%D0 = On, D1 = Off, Span 12.8KHz
%data21 = importdata('SRS021.mat');
data22 = importdata('SRS022.mat');
%D0 = On, D1 = Off, Span 200Hz
%data23 = importdata('SRS023.mat');
%data34 = importdata('SRS034.mat');
data52 = importdata('SRS052.mat');

%D0 = On, D1 = On, Span 102.4KHz
%data26 = importdata('SRS026.mat');
%data32 = importdata('SRS032.mat');
data53 = importdata('SRS053.mat');
%D0 = On, D1 = On, Span 200Hz
%data25 = importdata('SRS025.mat');
%data31 = importdata('SRS031.mat');
data54 = importdata('SRS054.mat');

%D0 = Off, D1 = On, Span 102.4KHz
%data27 = importdata('SRS027.mat');
data55 = importdata('SRS055.mat');
%D0 = Off, D1 = On, Span 12.8KHz
%data28 = importdata('SRS028.mat');
data56 = importdata('SRS056.mat');
%D0 = Off, D1 = On, Span 1.6KHz
%data29 = importdata('SRS029.mat');
data57 = importdata('SRS057.mat');
%D0 = Off, D1 = On, Span 200Hz
%data30 = importdata('SRS030.mat');
data58 = importdata('SRS058.mat');

% Calculate average values from 1kHz to 2kHz
aveB00_N = mean(data48(66:126,2));
aveB10_N = mean(data51(9:17,2));
aveB11_N = mean(data53(9:17,2));
aveB01_N = mean(data56(66:126,2));

%% Board Side A:
%D0 = Off, D1 = Off, Span 102.4KHz
%data35 = importdata('SRS035.mat');
data84 = importdata('SRS084.mat');
%D0 = Off, D1 = Off, Span 12.8KHz
%data36 = importdata('SRS036.mat');
data85 = importdata('SRS085.mat');
%D0 = Off, D1 = Off, Span 1.6KHz
%data37 = importdata('SRS037.mat');
data86 = importdata('SRS086.mat');
%D0 = Off, D1 = Off, Span 200Hz
%data38 = importdata('SRS038.mat');
data87 = importdata('SRS087.mat');

%D0 = On, D1 = Off, Span 102.4KHz
%data39 = importdata('SRS039.mat');
data88 = importdata('SRS086.mat');
%D0 = On, D1 = Off, Span 200Hz
%data40 = importdata('SRS040.mat');
data89 = importdata('SRS089.mat');

%D0 = On, D1 = On, Span 102.4KHz
%data41 = importdata('SRS041.mat');
data90 = importdata('SRS090.mat');
%D0 = On, D1 = On, Span 200Hz
%data42 = importdata('SRS042.mat');
data91 = importdata('SRS091.mat');

%D0 = Off, D1 = On, Span 102.4KHz
%data43 = importdata('SRS043.mat');
data92 = importdata('SRS092.mat');
%D0 = Off, D1 = On, Span 12.8KHz
%data44 = importdata('SRS044.mat');
data93 = importdata('SRS093.mat');
%D0 = Off, D1 = On, Span 1.6KHz
%data45 = importdata('SRS045.mat');
data94 = importdata('SRS094.mat');
%D0 = Off, D1 = On, Span 200Hz
%data46 = importdata('SRS046.mat');
data95 = importdata('SRS095.mat');

% Calculate average values from 1kHz to 2kHz
aveA00_N = mean(data85(66:126,2));
aveA10_N = mean(data88(9:17,2));
aveA11_N = mean(data90(9:17,2));
aveA01_N = mean(data93(66:126,2));

%% Frequency Spans
freq1 = linspace(0,102.4,801);
freq2 = linspace(0, 12.8, 801);
freq3 = linspace(0, 1.6, 801);
freq4 = linspace(0, .2, 801);

freqvector = horzcat (freq4, freq3(1,100:801),freq2(1,100:801),freq1(1,100:801));
freqvector2 = horzcat (freq4,freq1(1,2:801));
freqvector3 = horzcat (freq4, freq2(1,13:801), freq1(1,100:801));

%% Concatenate data

B00_N = vertcat (data50(:,2),data49(100:801,2),data48(100:801,2),data47(100:801,2));
B10_N = vertcat (data52(:,2),data51(2:801,2));
B11_N = vertcat (data54(:,2),data53(2:801,2));
B01_N = vertcat (data58(:,2),data57(100:801,2),data56(100:801,2),data55(100:801,2));

A00_N = vertcat (data87(:,2),data86(100:801,2),data85(100:801,2),data84(100:801,2));
A10_N = vertcat (data89(:,2),data88(2:801,2));
A11_N = vertcat (data91(:,2),data90(2:801,2));
A01_N = vertcat (data95(:,2),data94(100:801,2),data93(100:801,2),data92(100:801,2));



%% Plots
figure(1)
subplot(2,2,1)
loglog(freqvector,B00_N);
title('Noise Signal for -- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,2)
loglog(freqvector2, B10_N);
title('Noise Signal for x- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,3)
loglog(freqvector2, B11_N);
title('Noise Signal for xx gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,4)
loglog(freqvector, B01_N);
title('Noise Signal for -x gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;


figure(2)
subplot(2,2,1)
loglog(freqvector, A00_N);
title('Noise Signal for -- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,2)
loglog(freqvector2, A10_N);
title('Noise Signal for x- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,3)
loglog(freqvector2, A11_N);
title('Noise Signal for xx gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
subplot(2,2,4)
loglog(freqvector, A01_N);
title('Noise Signal for -x gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;