%-------------------------------------------------------------------------%
%                                                                         %
% Amplitude-Signal Spectral Density for Dual PD Amp -- measures           %
%   the shot noise output from the board from a photodiode and LED source %
% Data from SR785                                                         %
%                                                                         %
%-------------------------------------------------------------------------%

%% Board Side B:

%D0 = Off, D1 = Off, Span 102.4KHz @ 9.79V
data62 = importdata('SRS062.mat');
%D0 = Off, D1 = Off, Span 12.8KHz @ 9.79V
data63 = importdata('SRS060.mat');
%D0 = Off, D1 = Off, Span 1.6KHz @ 10.30V
%data64 = importdata('SRS064.mat');
data65 = importdata('SRS065.mat');
%D0 = Off, D1 = Off, Span 200Hz @ 10.30V
data66 = importdata('SRS066.mat');


%D0 = On, D1 = Off, Span 102.4KHz
data67 = importdata('SRS067.mat'); % @ 13.09V
data77 = importdata('SRS077.mat'); % @ 10.08V
%D0 = On, D1 = Off, Span 12.8KHz
%data68 = importdata('SRS069.mat'); % @ 13.09V
data78 = importdata('SRS078.mat'); % @ 10.08V
%D0 = On, D1 = Off, Span 200Hz
data68 = importdata('SRS068.mat'); % @ 13.09V


%D0 = On, D1 = On, Span 102.4KHz @ 9.90V
data70 = importdata('SRS070.mat');
%D0 = On, D1 = On, Span 12.8KHz @ 9.90V
data71 = importdata('SRS071.mat');
%D0 = On, D1 = On, Span 200Hz @ 9.90V
data72 = importdata('SRS072.mat');

%D0 = Off, D1 = On, Span 102.4KHz @ 9.81V
data73 = importdata('SRS073.mat');
%D0 = Off, D1 = On, Span 12.8KHz 9.81V
data74 = importdata('SRS074.mat');
%D0 = Off, D1 = On, Span 1.6KHz 9.81V
data75 = importdata('SRS075.mat');
%D0 = Off, D1 = On, Span 200Hz 9.81V
data76 = importdata('SRS076.mat');

% Calculate shot noise by subtracting electronic noise (NS) -- need to
%   convert to power first
Sdata62(:,2) = sqrt(data62(:,2).^2-data47(:,2).^2);
Sdata63(:,2) = sqrt(data63(:,2).^2-data48(:,2).^2);
Sdata65(:,2) = sqrt(data65(:,2).^2-data49(:,2).^2);
Sdata66(:,2) = sqrt(data66(:,2).^2-data50(:,2).^2);

Sdata77(:,2) = sqrt(data77(:,2).^2-data51(:,2).^2);
Sdata68(:,2) = sqrt(data68(:,2).^2-data52(:,2).^2);

Sdata70(:,2) = sqrt(data77(:,2).^2-data53(:,2).^2);
Sdata72(:,2) = sqrt(data78(:,2).^2-data54(:,2).^2);

Sdata73(:,2) = sqrt(data73(:,2).^2-data55(:,2).^2);
Sdata74(:,2) = sqrt(data74(:,2).^2-data56(:,2).^2);
Sdata75(:,2) = sqrt(data75(:,2).^2-data57(:,2).^2);
Sdata76(:,2) = sqrt(data76(:,2).^2-data58(:,2).^2);

% Calculate average values from 1kHz to 2kHz
aveB00_T = mean(data63(66:126,2));
aveB10_T = mean(data77(9:17,2));
aveB11_T = mean(data71(66:126,2));
aveB01_T = mean(data74(66:126,2));

aveB00_S = mean(Sdata63(66:126,2));
aveB10_S = mean(Sdata77(9:17,2));
aveB11_S = mean(Sdata70(9:17,2));
aveB01_S = mean(Sdata74(66:126,2));

%% Board Side A

%D0 = Off, D1 = Off, Span 102.4KHz @ 9.85V
data96 = importdata('SRS096.mat');
%D0 = Off, D1 = Off, Span 12.8KHz @ 9.85V
data97 = importdata('SRS097.mat');
%D0 = Off, D1 = Off, Span 1.6KHz @ 9.85V
data98 = importdata('SRS098.mat');
%D0 = Off, D1 = Off, Span 200Hz @ 9.85V
data99 = importdata('SRS099.mat');


%D0 = On, D1 = Off, Span 102.4KHz @ 9.4V
data100 = importdata('SRS100.mat');  
%D0 = On, D1 = Off, Span 12.8KHz @ 9.4V
data101 = importdata('SRS101.mat');
%D0 = On, D1 = Off, Span 200Hz @ 9.4V
data102 = importdata('SRS102.mat'); 


%D0 = On, D1 = On, Span 102.4KHz @ 9.75V
data103 = importdata('SRS103.mat');
%D0 = On, D1 = On, Span 12.8KHz @ 9.75V
data104 = importdata('SRS104.mat');
%D0 = On, D1 = On, Span 200Hz @ 9.75V
data105 = importdata('SRS105.mat');

%D0 = Off, D1 = On, Span 102.4KHz @ 9.2V
data106 = importdata('SRS106.mat');
%D0 = Off, D1 = On, Span 12.8KHz 9.2V
data107 = importdata('SRS107.mat');
%D0 = Off, D1 = On, Span 1.6KHz 9.2V
data108 = importdata('SRS108.mat');
%D0 = Off, D1 = On, Span 200Hz 9.2V
data109 = importdata('SRS109.mat');

% Calculate shot noise by subtracting electronic noise (NS) -- need to
%   convert to power first
Sdata96(:,2) = sqrt(data96(:,2).^2-data84(:,2).^2);
Sdata97(:,2) = sqrt(data97(:,2).^2-data85(:,2).^2);
Sdata98(:,2) = sqrt(data98(:,2).^2-data86(:,2).^2);
Sdata99(:,2) = sqrt(data99(:,2).^2-data87(:,2).^2);

Sdata100(:,2) = sqrt(data100(:,2).^2-data88(:,2).^2);
Sdata102(:,2) = sqrt(data102(:,2).^2-data89(:,2).^2);

Sdata103(:,2) = sqrt(data103(:,2).^2-data90(:,2).^2);
Sdata105(:,2) = sqrt(data105(:,2).^2-data91(:,2).^2);

Sdata106(:,2) = sqrt(data106(:,2).^2-data92(:,2).^2);
Sdata107(:,2) = sqrt(data107(:,2).^2-data93(:,2).^2);
Sdata108(:,2) = sqrt(data108(:,2).^2-data94(:,2).^2);
Sdata109(:,2) = sqrt(data109(:,2).^2-data95(:,2).^2);

% Calculate average values from 1kHz to 2kHz
aveA00_T = mean(data97(66:126,2));
aveA10_T = mean(data101(66:126,2));
aveA11_T = mean(data104(66:126,2));
aveA01_T = mean(data107(66:126,2));

aveA00_S = mean(Sdata97(66:126,2));
aveA10_S = mean(Sdata100(9:17,2));
aveA11_S = mean(Sdata103(9:17,2));
aveA01_S = mean(Sdata107(66:126,2));

%% Frequency Spans
freq1 = linspace(0,102.4,801);
freq2 = linspace(0, 12.8, 801);
freq3 = linspace(0, 1.6, 801);
freq4 = linspace(0, .2, 801);

freqvector = horzcat (freq4, freq3(1,100:801),freq2(1,100:801),freq1(1,100:801));
freqvector2 = horzcat (freq2,freq1(1,100:801));
freqvector3 = horzcat (freq4, freq2(1,13:801), freq1(1,100:801));
freqvector4 = horzcat (freq4, freq1(1,1:801));


%% Concatenate data
% Total noise
B00_T = vertcat (data66(:,2),data65(100:801,2),data63(100:801,2),data62(100:801,2));
B10_T = vertcat (data68(:,2),data77(13:801,2), data78(100:801,2));
B11_T = vertcat (data72(:,2),data71(13:801,2),data70(100:801,2));
B01_T = vertcat (data76(:,2),data75(100:801,2),data74(100:801,2),data73(100:801,2));

A00_T = vertcat (data99(:,2),data98(100:801,2),data97(100:801,2),data96(100:801,2));
A10_T = vertcat (data102(:,2),data101(13:801,2),data100(100:801,2));
A11_T = vertcat (data105(:,2),data104(13:801,2),data103(100:801,2));
A01_T = vertcat (data109(:,2),data108(100:801,2),data107(100:801,2),data106(100:801,2));

% Shot noise (electrical noise subtracted out)
B00_S = vertcat (Sdata66(:,2),Sdata65(100:801,2),Sdata63(100:801,2),Sdata62(100:801,2));
B10_S = vertcat (Sdata77(:,2),Sdata68(1:801,2));
B11_S = vertcat (Sdata72(:,2),Sdata70(1:801,2));
B01_S = vertcat (Sdata76(:,2),Sdata75(100:801,2),Sdata74(100:801,2),Sdata73(100:801,2));

A00_S = vertcat (Sdata99(:,2),Sdata98(100:801,2),Sdata97(100:801,2),Sdata96(100:801,2));
A10_S = vertcat (Sdata102(:,2),Sdata100(1:801,2));
A11_S = vertcat (Sdata105(:,2),Sdata103(1:801,2));
A01_S = vertcat (Sdata109(:,2),Sdata108(100:801,2),Sdata107(100:801,2),Sdata106(100:801,2));
%% Slide B Plots

figure(1)
subplot(2,2,1)
loglog(freqvector, 80*10^-9); % Expected shot noise 
hold on
loglog(f2,B00_T);
title(' Total Noise for -- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,2)
loglog(freqvector, 142*10^-9); % Expected shot noise 
hold on
loglog(freqvector3, B10_T);
title('Total Noise for x- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,3)
loglog(freqvector, 253*10^-9); % Expected shot noise 
hold on
loglog(freqvector3, B11_T);
title('Total Noise for xx gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,4)
loglog(freqvector, 449*10^-9); % Expected shot noise 
hold on 
loglog(freqvector, B01_T);
title('Total Noise for -x gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off


%% No light source data for board side B
% data61 = importdata('SRS061.mat');
% 
% figure(2)
% loglog(freq1,data61(:,2));
% title('Noise from side B with no light source');
% xlabel('kHz');
% ylabel('Vrms/Hz^-2');
% grid;

%% Slide A Plots

figure(2)
subplot(2,2,1)
loglog(freqvector, 80*10^-9); % Expected shot noise 
hold on
loglog(freqvector, A00_S);
title(' Shot Noise for -- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,2)
loglog(freqvector, 142*10^-9); % Expected shot noise 
hold on
loglog(freqvector4, A10_S);
title('Shot Noise for x- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,3)
loglog(freqvector, 253*10^-9); % Expected shot noise 
hold on
loglog(freqvector4, A11_S);
title('Shot Noise for xx gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,4)
loglog(freqvector, 449*10^-9); % Expected shot noise 
hold on 
loglog(freqvector, A01_S);
title('Shot Noise for -x gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off

%% Comparison of Noise
figure(4)
loglog(freqvector,A01_S, 'b',freqvector,A00_S,'g');
legend('-+ gain', '-- gain');
title('Shot Noise of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;

figure(5)
loglog(freqvector, 449*10^-9,freqvector,A01_S, 'b',freqvector,A01_T,'g',freqvector, A01_N);
legend('Shot Noise','Total Noise', 'Electrical Noise');
title('Noise for -x gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;