(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     33193,       1001]
NotebookOptionsPosition[     29696,        877]
NotebookOutlinePosition[     30054,        893]
CellTagsIndexPosition[     30011,        890]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
ALS Fiber Distribution Test Data\
\>", "Title",
 CellChangeTimes->{{3.5512081404347677`*^9, 3.551208148145295*^9}}],

Cell[CellGroupData[{

Cell["S1202532", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551208154321344*^9, 3.551208155545768*^9}, {3.55163871984622*^9, 
  3.5516387282025003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list11", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "21.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "22.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "23.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "24.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "25.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "26.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "27.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "28.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "29.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "30"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "30.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "31.7"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951198201849*^9, 3.550951201844212*^9}, {
  3.5509514586800003`*^9, 3.55095149074969*^9}, {3.550951528622838*^9, 
  3.550951626623485*^9}, {3.551207287982562*^9, 3.551207288165537*^9}}],

Cell["\<\
AOM input (dBm) vs. Coupler OUT to AOM (dBm)\
\>", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list11", "]"}]], "Input",
 CellChangeTimes->{{3.550951493119343*^9, 3.5509515195732527`*^9}, {
  3.551207291027238*^9, 3.551207291211187*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 21.9}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.4}, {7., 28.3}, {8., 29.2}, {9., 30.}, {10., 30.9}, {11.,
      31.7}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {21.9, 31.7}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.550951496370207*^9, 3.5509515203967457`*^9}, 
   3.550951630663275*^9, 3.551207303400096*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"list12", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1.052"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1.028"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1.004"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0.979"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0.955"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "0.93"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "0.905"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0.880"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "0.855"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "0.831"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.808"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "0.785"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951650873207*^9, 3.5509517317753773`*^9}, 
   3.5512072926773567`*^9}],

Cell["AOM inpu (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list12", "]"}]], "Input",
 CellChangeTimes->{{3.550951734866621*^9, 3.550951739269099*^9}, 
   3.551207294115362*^9}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 1.052}, {1., 1.028}, {2., 1.004}, {3., 0.979}, {4., 
     0.955}, {5., 0.93}, {6., 0.905}, {7., 0.88}, {8., 0.855}, {9., 0.831}, {
     10., 0.808}, {11., 0.785}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.78},
  PlotRange->{{0., 11.}, {0.78, 1.052}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.55095174020936*^9, 3.551207308633526*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"line", " ", "=", " ", 
  RowBox[{"Fit", "[", 
   RowBox[{"list12", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5509553590230427`*^9, 3.5509553725611477`*^9}, 
   3.551207297835409*^9}],

Cell[BoxData[
 RowBox[{"1.05224358974359`", "\[VeryThinSpace]", "-", 
  RowBox[{"0.02446853146853147`", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.550955373581716*^9, 3.5512073114217367`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["S1202528", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551207285122251*^9, 3.551207285249605*^9}, {3.5512081588654213`*^9, 
  3.551208159425349*^9}, {3.551638737282015*^9, 3.5516387420351057`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list21", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "22.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "23"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "23.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "24.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "25.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "26.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "27.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "28.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "29.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "30.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "31"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "31.9"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951198201849*^9, 3.550951201844212*^9}, {
  3.5509514586800003`*^9, 3.55095149074969*^9}, {3.550951528622838*^9, 
  3.550951626623485*^9}, {3.551207329375311*^9, 3.5512073802773457`*^9}}],

Cell["AOM input (dBm) vs. Coupler OUT to AOM (dBm)", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list21", "]"}]], "Input",
 CellChangeTimes->{{3.550951493119343*^9, 3.5509515195732527`*^9}, {
  3.5512073819873123`*^9, 3.5512073821072063`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 22.1}, {1., 23.}, {2., 23.9}, {3., 24.9}, {4., 25.8}, {5., 
     26.7}, {6., 27.6}, {7., 28.4}, {8., 29.3}, {9., 30.2}, {10., 31.}, {11., 
     31.9}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {22., 31.9}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.550951496370207*^9, 3.5509515203967457`*^9}, 
   3.550951630663275*^9, 3.551207385426297*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"list22", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.999"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.974"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0.949"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0.924"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0.898"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "0.812"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "0.846"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0.821"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "0.796"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "0.771"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.746"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "0.723"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951650873207*^9, 3.5509517317753773`*^9}, {
  3.551207390014471*^9, 3.55120745644392*^9}}],

Cell["AOM inpu (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list22", "]"}]], "Input",
 CellChangeTimes->{{3.550951734866621*^9, 3.550951739269099*^9}, 
   3.551207457987174*^9}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 0.999}, {1., 0.974}, {2., 0.949}, {3., 0.924}, {4., 
     0.898}, {5., 0.812}, {6., 0.846}, {7., 0.821}, {8., 0.796}, {9., 
     0.771}, {10., 0.746}, {11., 0.723}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.72},
  PlotRange->{{0., 11.}, {0.72, 0.999}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.55095174020936*^9, 3.5512074636874638`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"line", " ", "=", " ", 
  RowBox[{"Fit", "[", 
   RowBox[{"list22", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5509553590230427`*^9, 3.5509553725611477`*^9}, 
   3.551207479372938*^9}],

Cell[BoxData[
 RowBox[{"0.9928205128205133`", "\[VeryThinSpace]", "-", 
  RowBox[{"0.025073426573426594`", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.550955373581716*^9, 3.551207481563813*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["S1202529", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551207505531176*^9, 3.551207505665737*^9}, {3.5512081622013683`*^9, 
  3.551208170801262*^9}, {3.5516387474746113`*^9, 3.551638751763026*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list31", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "21.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "22.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "23.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "24.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "25.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "26.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "27.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "28.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "29.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "30.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "30.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "31.7"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951198201849*^9, 3.550951201844212*^9}, {
  3.5509514586800003`*^9, 3.55095149074969*^9}, {3.550951528622838*^9, 
  3.550951626623485*^9}, {3.551207287982562*^9, 3.551207288165537*^9}, {
  3.551207539245702*^9, 3.551207567165422*^9}}],

Cell["AOM input (dBm) vs. Coupler OUT to AOM (dBm)", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list31", "]"}]], "Input",
 CellChangeTimes->{{3.550951493119343*^9, 3.5509515195732527`*^9}, {
  3.551207291027238*^9, 3.551207291211187*^9}, {3.551207574941208*^9, 
  3.5512075752673273`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 21.9}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.4}, {7., 28.3}, {8., 29.2}, {9., 30.1}, {10., 30.9}, {
     11., 31.7}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {21.9, 31.7}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.550951496370207*^9, 3.5509515203967457`*^9}, 
   3.550951630663275*^9, 3.551207303400096*^9, 3.551207575587509*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"list32", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.994"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.968"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0.943"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0.918"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0.892"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "0.866"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "0.840"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0.815"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "0.790"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "0.765"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.742"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "0.719"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951650873207*^9, 3.5509517317753773`*^9}, 
   3.5512072926773567`*^9, {3.551207582349738*^9, 3.551207666261365*^9}}],

Cell["AOM inpu (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list32", "]"}]], "Input",
 CellChangeTimes->{{3.550951734866621*^9, 3.550951739269099*^9}, 
   3.551207294115362*^9, {3.551207667755816*^9, 3.551207667867148*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 0.994}, {1., 0.968}, {2., 0.943}, {3., 0.918}, {4., 
     0.892}, {5., 0.866}, {6., 0.84}, {7., 0.815}, {8., 0.79}, {9., 0.765}, {
     10., 0.742}, {11., 0.719}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.72},
  PlotRange->{{0., 11.}, {0.719, 0.994}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.55095174020936*^9, 3.551207308633526*^9, 
  3.5512076719467573`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"line", " ", "=", " ", 
  RowBox[{"Fit", "[", 
   RowBox[{"list32", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5509553590230427`*^9, 3.5509553725611477`*^9}, 
   3.551207297835409*^9, {3.55120767467747*^9, 3.5512076752915993`*^9}}],

Cell[BoxData[
 RowBox[{"0.992833333333334`", "\[VeryThinSpace]", "-", 
  RowBox[{"0.0251818181818182`", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.550955373581716*^9, 3.5512073114217367`*^9, 
  3.551207676951721*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["S1202530", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551207285122251*^9, 3.551207285249605*^9}, {3.5512075090891733`*^9, 
  3.551207509865713*^9}, {3.5512081672013607`*^9, 3.551208167969454*^9}, {
  3.551638756082624*^9, 3.5516387636265*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list41", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "22"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "23"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "23.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "24.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "25.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "26.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "27.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "28.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "29.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "30.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "31"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "31.9"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951198201849*^9, 3.550951201844212*^9}, {
  3.5509514586800003`*^9, 3.55095149074969*^9}, {3.550951528622838*^9, 
  3.550951626623485*^9}, {3.551207329375311*^9, 3.5512073802773457`*^9}, {
  3.5512077084799643`*^9, 3.5512077087015457`*^9}, {3.551207808845209*^9, 
  3.5512078089972963`*^9}}],

Cell["AOM input (dBm) vs. Coupler OUT to AOM (dBm)", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list41", "]"}]], "Input",
 CellChangeTimes->{{3.550951493119343*^9, 3.5509515195732527`*^9}, {
  3.5512073819873123`*^9, 3.5512073821072063`*^9}, {3.551207810538616*^9, 
  3.551207810651127*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 22.}, {1., 23.}, {2., 23.9}, {3., 24.9}, {4., 25.8}, {5., 
     26.7}, {6., 27.6}, {7., 28.4}, {8., 29.3}, {9., 30.2}, {10., 31.}, {11., 
     31.9}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {22., 31.9}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.550951496370207*^9, 3.5509515203967457`*^9}, 
   3.550951630663275*^9, 3.551207385426297*^9, 3.551207820108457*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"list42", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1.017"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.991"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0.965"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0.940"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0.913"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "0.888"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "0.862"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0.836"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "0.811"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "0.785"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.761"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "0.738"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951650873207*^9, 3.5509517317753773`*^9}, {
  3.551207390014471*^9, 3.55120745644392*^9}, {3.551207727605865*^9, 
  3.551207813717456*^9}}],

Cell["AOM inpu (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list42", "]"}]], "Input",
 CellChangeTimes->{{3.550951734866621*^9, 3.550951739269099*^9}, 
   3.551207457987174*^9, {3.551207792731848*^9, 3.551207815587139*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 1.017}, {1., 0.991}, {2., 0.965}, {3., 0.94}, {4., 
     0.913}, {5., 0.888}, {6., 0.862}, {7., 0.836}, {8., 0.811}, {9., 
     0.785}, {10., 0.761}, {11., 0.738}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.74},
  PlotRange->{{0., 11.}, {0.738, 1.017}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.55095174020936*^9, 3.5512074636874638`*^9, {3.5512077978869553`*^9, 
   3.551207823609427*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"line", " ", "=", " ", 
  RowBox[{"Fit", "[", 
   RowBox[{"list42", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5509553590230427`*^9, 3.5509553725611477`*^9}, 
   3.551207479372938*^9, {3.551207802545014*^9, 3.551207803099845*^9}}],

Cell[BoxData[
 RowBox[{"1.0159871794871798`", "\[VeryThinSpace]", "-", 
  RowBox[{"0.025527972027972037`", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.550955373581716*^9, 3.551207481563813*^9, 
  3.551207826080492*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["S1202531", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551207524267777*^9, 3.551207524537088*^9}, {3.551208175985063*^9, 
  3.551208176416833*^9}, {3.551638767826651*^9, 3.551638769962632*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"list51", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "21.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "22.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "23.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "24.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "25.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "26.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "27.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "28.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "29.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "30.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "31"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "31.8"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951198201849*^9, 3.550951201844212*^9}, {
  3.5509514586800003`*^9, 3.55095149074969*^9}, {3.550951528622838*^9, 
  3.550951626623485*^9}, {3.551207287982562*^9, 3.551207288165537*^9}, {
  3.551207834805601*^9, 3.5512078352535763`*^9}, {3.55120786581351*^9, 
  3.551207908341496*^9}, {3.551207992640047*^9, 3.5512080337093077`*^9}}],

Cell["AOM input (dBm) vs. Coupler OUT to AOM (dBm)", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list51", "]"}]], "Input",
 CellChangeTimes->{{3.550951493119343*^9, 3.5509515195732527`*^9}, {
  3.551207291027238*^9, 3.551207291211187*^9}, {3.551207837123177*^9, 
  3.551207837219306*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 21.8}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.5}, {7., 28.3}, {8., 29.2}, {9., 30.1}, {10., 31.}, {11.,
      31.8}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {21.8, 31.8}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.550951496370207*^9, 3.5509515203967457`*^9}, 
   3.550951630663275*^9, 3.551207303400096*^9, 3.551207911106748*^9, 
   3.551208037079393*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"list52", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1.005"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.979"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0.953"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0.927"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "0.900"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "0.874"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "0.847"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0.822"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "0.796"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "0.771"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "0.747"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "0.723"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.550951650873207*^9, 3.5509517317753773`*^9}, 
   3.5512072926773567`*^9, {3.55120783924584*^9, 3.551207839356985*^9}, {
   3.551207963189514*^9, 3.5512079633895073`*^9}, {3.551208040685458*^9, 
   3.55120812034938*^9}}],

Cell["AOM inpu (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "list52", "]"}]], "Input",
 CellChangeTimes->{{3.550951734866621*^9, 3.550951739269099*^9}, 
   3.551207294115362*^9, {3.551207840827849*^9, 3.551207840939165*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 1.005}, {1., 0.979}, {2., 0.953}, {3., 0.927}, {4., 0.9}, {
     5., 0.874}, {6., 0.847}, {7., 0.822}, {8., 0.796}, {9., 0.771}, {10., 
     0.747}, {11., 0.723}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.72},
  PlotRange->{{0., 11.}, {0.72, 1.005}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.55095174020936*^9, 3.551207308633526*^9, 
  3.5512081243194532`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"line", " ", "=", " ", 
  RowBox[{"Fit", "[", 
   RowBox[{"list52", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5509553590230427`*^9, 3.5509553725611477`*^9}, 
   3.551207297835409*^9, {3.5512078439798527`*^9, 3.551207844066853*^9}}],

Cell[BoxData[
 RowBox[{"1.0039230769230771`", "\[VeryThinSpace]", "-", 
  RowBox[{"0.02580419580419581`", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.550955373581716*^9, 3.5512073114217367`*^9, 
  3.551208129228054*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["All together...", "Section",
 CellChangeTimes->{{3.551207240747674*^9, 3.5512072430737267`*^9}, {
  3.551207524267777*^9, 3.551207524537088*^9}, {3.551208175985063*^9, 
  3.551208176416833*^9}, {3.551208411403138*^9, 3.551208413921178*^9}}],

Cell["AOM input (dBm) vs. Coupler OUT to AOM (dBm)", "Text",
 CellChangeTimes->{{3.5509554478993273`*^9, 3.5509554889673433`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"{", 
   RowBox[{
   "list11", ",", "list21", ",", "list31", ",", "list41", ",", "list51"}], 
   "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.551208298538632*^9, 3.5512083225140944`*^9}, {
  3.551208367635639*^9, 3.55120836993158*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 21.9}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.4}, {7., 28.3}, {8., 29.2}, {9., 30.}, {10., 30.9}, {11.,
      31.7}}]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], 
    PointBox[{{0., 22.1}, {1., 23.}, {2., 23.9}, {3., 24.9}, {4., 25.8}, {5., 
     26.7}, {6., 27.6}, {7., 28.4}, {8., 29.3}, {9., 30.2}, {10., 31.}, {11., 
     31.9}}]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], 
    PointBox[{{0., 21.9}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.4}, {7., 28.3}, {8., 29.2}, {9., 30.1}, {10., 30.9}, {
     11., 31.7}}]}, 
   {Hue[0.37820393249936934`, 0.6, 0.6], 
    PointBox[{{0., 22.}, {1., 23.}, {2., 23.9}, {3., 24.9}, {4., 25.8}, {5., 
     26.7}, {6., 27.6}, {7., 28.4}, {8., 29.3}, {9., 30.2}, {10., 31.}, {11., 
     31.9}}]}, 
   {Hue[0.6142719099991583, 0.6, 0.6], 
    PointBox[{{0., 21.8}, {1., 22.8}, {2., 23.8}, {3., 24.7}, {4., 25.6}, {5.,
      26.5}, {6., 27.5}, {7., 28.3}, {8., 29.2}, {9., 30.1}, {10., 31.}, {11.,
      31.8}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 22.},
  PlotRange->{{0., 11.}, {21.8, 31.9}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.551208323977162*^9, 3.5512083704457617`*^9}]
}, Open  ]],

Cell["AOM input (dBm) vs. M1 (Volts)", "Text",
 CellChangeTimes->{{3.550955481799033*^9, 3.55095550079117*^9}, 
   3.551208977541128*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"{", 
   RowBox[{
   "list12", ",", "list22", ",", "list32", ",", "list42", ",", "list52"}], 
   "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5512084238838043`*^9, 3.551208430979414*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., 1.052}, {1., 1.028}, {2., 1.004}, {3., 0.979}, {4., 
     0.955}, {5., 0.93}, {6., 0.905}, {7., 0.88}, {8., 0.855}, {9., 0.831}, {
     10., 0.808}, {11., 0.785}}]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], 
    PointBox[{{0., 0.999}, {1., 0.974}, {2., 0.949}, {3., 0.924}, {4., 
     0.898}, {5., 0.812}, {6., 0.846}, {7., 0.821}, {8., 0.796}, {9., 
     0.771}, {10., 0.746}, {11., 0.723}}]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], 
    PointBox[{{0., 1.017}, {1., 0.991}, {2., 0.965}, {3., 0.94}, {4., 
     0.913}, {5., 0.888}, {6., 0.862}, {7., 0.836}, {8., 0.811}, {9., 
     0.785}, {10., 0.761}, {11., 0.738}}]}, 
   {Hue[0.37820393249936934`, 0.6, 0.6], 
    PointBox[{{0., 1.017}, {1., 0.991}, {2., 0.965}, {3., 0.94}, {4., 
     0.913}, {5., 0.888}, {6., 0.862}, {7., 0.836}, {8., 0.811}, {9., 
     0.785}, {10., 0.761}, {11., 0.738}}]}, 
   {Hue[0.6142719099991583, 0.6, 0.6], 
    PointBox[{{0., 1.005}, {1., 0.979}, {2., 0.953}, {3., 0.927}, {4., 0.9}, {
     5., 0.874}, {6., 0.847}, {7., 0.822}, {8., 0.796}, {9., 0.771}, {10., 
     0.747}, {11., 0.723}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.72},
  PlotRange->{{0., 11.}, {0.72, 1.052}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.551208431458827*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{740, 707},
WindowMargins->{{298, Automatic}, {Automatic, 46}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 125, 3, 76, "Title"],
Cell[CellGroupData[{
Cell[729, 29, 194, 3, 67, "Section"],
Cell[926, 34, 1114, 31, 43, "Input"],
Cell[2043, 67, 138, 3, 26, "Text"],
Cell[CellGroupData[{
Cell[2206, 74, 183, 3, 27, "Input"],
Cell[2392, 79, 591, 15, 242, "Output"]
}, Open  ]],
Cell[2998, 97, 1012, 30, 43, "Input"],
Cell[4013, 129, 110, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[4148, 134, 158, 3, 27, "Input"],
Cell[4309, 139, 551, 14, 239, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4897, 158, 278, 7, 27, "Input"],
Cell[5178, 167, 194, 3, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5421, 176, 243, 3, 67, "Section"],
Cell[5667, 181, 1114, 31, 43, "Input"],
Cell[6784, 214, 130, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[6939, 219, 187, 3, 27, "Input"],
Cell[7129, 224, 589, 15, 247, "Output"]
}, Open  ]],
Cell[7733, 242, 1033, 30, 43, "Input"],
Cell[8769, 274, 110, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[8904, 279, 158, 3, 27, "Input"],
Cell[9065, 284, 555, 14, 241, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9657, 303, 278, 7, 27, "Input"],
Cell[9938, 312, 195, 3, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10182, 321, 243, 3, 67, "Section"],
Cell[10428, 326, 1165, 32, 43, "Input"],
Cell[11596, 360, 130, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[11751, 365, 234, 4, 27, "Input"],
Cell[11988, 371, 614, 15, 242, "Output"]
}, Open  ]],
Cell[12617, 389, 1059, 30, 43, "Input"],
Cell[13679, 421, 110, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[13814, 426, 204, 3, 27, "Input"],
Cell[14021, 431, 579, 15, 244, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14637, 451, 325, 7, 27, "Input"],
Cell[14965, 460, 219, 4, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15233, 470, 290, 4, 67, "Section"],
Cell[15526, 476, 1216, 33, 43, "Input"],
Cell[16745, 511, 130, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[16900, 516, 236, 4, 27, "Input"],
Cell[17139, 522, 610, 15, 247, "Output"]
}, Open  ]],
Cell[17764, 540, 1082, 31, 43, "Input"],
Cell[18849, 573, 110, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[18984, 578, 204, 3, 27, "Input"],
Cell[19191, 583, 610, 16, 237, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19838, 604, 324, 7, 27, "Input"],
Cell[20165, 613, 220, 4, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20434, 623, 239, 3, 67, "Section"],
Cell[20676, 628, 1261, 33, 43, "Input"],
Cell[21940, 663, 130, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[22095, 668, 232, 4, 27, "Input"],
Cell[22330, 674, 639, 16, 245, "Output"]
}, Open  ]],
Cell[22984, 693, 1159, 32, 43, "Input"],
Cell[24146, 727, 110, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[24281, 732, 204, 3, 27, "Input"],
Cell[24488, 737, 578, 15, 239, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25103, 757, 326, 7, 27, "Input"],
Cell[25432, 766, 221, 4, 27, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25702, 776, 246, 3, 67, "Section"],
Cell[25951, 781, 130, 1, 26, "Text"],
Cell[CellGroupData[{
Cell[26106, 786, 287, 7, 27, "Input"],
Cell[26396, 795, 1401, 30, 243, "Output"]
}, Open  ]],
Cell[27812, 828, 137, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[27974, 834, 239, 6, 27, "Input"],
Cell[28216, 842, 1440, 30, 239, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
